<!DOCTYPE html>
<html>

<head>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>
    <div class="container-fluid jumbotron">
        <div class="row d-flex align-items-center min-vh-100 p-5">
            <div class="col-md-12 mx-auto my-0 jumbotron bg-white p-5 px-5 signup-form">
                <div class="form-group">
                    <h2 class="text-center">Login to your account</h3>
                </div>
                <div class="form-group">
                    <input type="email" class="form-control" id="inp-email" placeholder="Email address">
                </div>
                <div class="form-group">
                    <input type="password" class="form-control" id="inp-password" placeholder="Password" required>
                </div>
                <div class="row form-group">
                    <div class="col-6">
                        <input type="checkbox" id="ckb-remember"> Remember account
                    </div>
                    <div class="col-6">
                        <p class="text-right">Lost password</p>
                    </div>
                </div>
                <div class="form-group">
                    <button id="btn-sign-in" class="btn btn-lg btn-block btn-primary">Sign in</button>
                </div>
                <div class="form-group">
                    or <a href="signup.html">sign-up</a> for having an account
                </div>
                <p id="show-cookie"></p>
            </div>
        </div>
    </div>
    <!-- Modal show message-->
    <div class="modal fade" id="modal-message">
        <div class="modal-dialog">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title">Thong bao</h5>
              <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <span aria-hidden="true">&times;</span>
              </button>
            </div>
            <div class="modal-body">
              <h6 id="message"></h6>
            </div>
            <div class="modal-footer">
              <button type="button" class="btn btn-secondary" data-dismiss="modal">
                Close
              </button>
            </div>
          </div>
        </div>
      </div>
</body>
<script>
    //Vùng 1: định nghĩa global variable (biến toàn cục)

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $("#btn-sign-in").on("click", function() {
        onBtnSignInClick();
    })

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onBtnSignInClick() {
        //B1  Thu Thập Dữ Liệu
        var vUserData = readDataFromFormSignIn();
        //B2  Kiểm tra dữ liệu
        var vIsValid = validateData(vUserData);
        if(vIsValid) {
          //B3 call APi Đăng Nhập
          callAjaxApiSignIn(vUserData);
        }
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function readDataFromFormSignIn() {
        var vUserData = {
            email: $.trim($("#inp-email").val()),
            password: $.trim($("#inp-password").val())
        }
        return vUserData;
    };
    // B2 Kiem Tra Du Lieu 
    function validateData(paramData){
        var vIsValid = false;
        if(paramData.email == ""){
            showModalMessage("Chua Nhap Email")
        }
        else if(validateEmail(paramData.email) == false){
            showModalMessage("Email khong hop le")
        }
        else if(paramData.password == ""){
            showModalMessage("Chua Nhap password")
        }
        else 
            vIsValid = true;
        return vIsValid;
    }
    function validateEmail(paramEmail) {
        var vRegex = /^[^\s@]+@[^\s@]+\.[^\s@]+$/;
        return vRegex.test(paramEmail);
    }
    function showModalMessage(paramMessage) {
        "use strict";
        $("#message").html(paramMessage);
        $("#modal-message").modal("show");
    }
    function callAjaxApiSignIn(paramUserData){
        "use strict";
        var loginUrl = "http://42.115.221.44:8080/devcamp-auth/users/signin";
        var formData = new FormData();
        formData.append('email', paramUserData.email);
        formData.append('password', paramUserData.password);
        $.ajax({
            type: "POST",
            url: loginUrl,
            data: formData,
            async: false, 
            contentType: false,
            cache : false,
            processData: false,
            success: function(responseObject) {
                console.log(responseObject);
                alert("Login thanh cong. An OK de toi trang User Info");
                responseHandler(responseObject);
            },
            error: function(xhr) {
               // Lấy error message
               var errorMessage = xhr.responseJSON.message;
               showModalMessage(errorMessage);
            }
        });
    }
    //Xử lý object trả về khi login thành công
    function responseHandler(data) {
        setCookie("token", data.token, 1); //Lưu token vào cookie trong 1 ngày
        window.location.href = "user-info.html";
    }
    function setCookie(cname, cvalue, exdays) {
        var d = new Date();
        d.setTime(d.getTime() + (exdays*24*60*60*1000));
        var expires = "expires="+ d.toUTCString();
        document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
        $('#show-cookie').html(document.cookie);
    }

</script>
</html>